package org.dromara.biz.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.BizTaskFeedbackBo;
import org.dromara.biz.domain.vo.BizTaskFeedbackVo;
import org.dromara.biz.domain.BizTaskFeedback;
import org.dromara.biz.mapper.BizTaskFeedbackMapper;
import org.dromara.biz.service.IBizTaskFeedbackService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 任务反馈信息Service业务层处理
 *
 * @author chenle
 * @date 2025-05-23
 */
@RequiredArgsConstructor
@Service
public class BizTaskFeedbackServiceImpl implements IBizTaskFeedbackService {

    private final BizTaskFeedbackMapper baseMapper;


    /**
     * 查询任务反馈信息
     *
     * @param id 主键
     * @return 任务反馈信息
     */
    @Override
    public BizTaskFeedbackVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询任务反馈信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 任务反馈信息分页列表
     */
    @Override
    public TableDataInfo<BizTaskFeedbackVo> queryPageList(BizTaskFeedbackBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<BizTaskFeedback> lqw = buildQueryWrapper(bo);
        Page<BizTaskFeedbackVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的任务反馈信息列表
     *
     * @param bo 查询条件
     * @return 任务反馈信息列表
     */
    @Override
    public List<BizTaskFeedbackVo> queryList(BizTaskFeedbackBo bo) {
        LambdaQueryWrapper<BizTaskFeedback> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<BizTaskFeedback> buildQueryWrapper(BizTaskFeedbackBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<BizTaskFeedback> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(BizTaskFeedback::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getTaskNo()), BizTaskFeedback::getTaskNo, bo.getTaskNo());
        lqw.eq(bo.getWorkId() != null, BizTaskFeedback::getWorkId, bo.getWorkId());
        lqw.eq(bo.getUserId() != null, BizTaskFeedback::getUserId, bo.getUserId());
        lqw.like(StringUtils.isNotBlank(bo.getUserName()), BizTaskFeedback::getUserName, bo.getUserName());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), BizTaskFeedback::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getFile()), BizTaskFeedback::getFile, bo.getFile());
        lqw.eq(bo.getStatus() != null, BizTaskFeedback::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增任务反馈信息
     *
     * @param bo 任务反馈信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(BizTaskFeedbackBo bo) {
        BizTaskFeedback add = MapstructUtils.convert(bo, BizTaskFeedback.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改任务反馈信息
     *
     * @param bo 任务反馈信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(BizTaskFeedbackBo bo) {
        BizTaskFeedback update = MapstructUtils.convert(bo, BizTaskFeedback.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(BizTaskFeedback entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除任务反馈信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }


}
